// Generated by CoffeeScript 1.10.0
(function() {
  var Vector;

  Vector = (function() {
    function Vector(x, y, z) {
      this.x = x;
      this.y = y;
      this.z = z;
      return 0;
    }

    Vector.prototype.minus = function(vec) {
      return new Vector(this.x - vec.x, this.y - vec.y, this.z - vec.z);
    };

    Vector.prototype.add = function(vec) {
      return new Vector(this.x + vec.x, this.y + vec.y, this.z + vec.z);
    };

    Vector.prototype.crossProduct = function(vec) {
      return new Vector(this.y * vec.z - this.z * vec.y, this.z * vec.x - this.x * vec.z, this.x * vec.y - this.y * vec.x);
    };

    Vector.prototype.length = function() {
      return Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
    };

    Vector.prototype.euclideanDistanceTo = function(vec) {
      return (this.minus(vec)).length();
    };

    Vector.prototype.multiplyScalar = function(scalar) {
      return new Vector(this.x * scalar, this.y * scalar, this.z * scalar);
    };

    Vector.prototype.normalized = function() {
      return this.multiplyScalar(1.0 / this.length());
    };

    return Vector;

  })();

  module.exports = Vector;

}).call(this);
