// Generated by CoffeeScript 1.10.0
(function() {
  var StlParser, chalk, fs, path;

  fs = require('fs');

  path = require('path');

  chalk = require('chalk');

  StlParser = require('./StlParser');

  module.exports = function(options) {
    var stlParser;
    if (options.ascii) {
      options.type = 'ascii';
    }
    if (options.binary) {
      options.type = 'binary';
    }
    options.readableObjectMode = false;
    stlParser = new StlParser(options);
    if (process.stdin.isTTY) {
      return console.error(chalk.red('Stl-parser must be used by piping into it'));
    } else {
      process.stdin.pipe(stlParser).pipe(process.stdout);
      stlParser.on('error', function(error) {
        return console.error(chalk.red(error.stack));
      });
      stlParser.on('warning', function(warning) {
        return console.warn(chalk.yellow('Warning:', warning));
      });
      return stlParser.on('debug', function(debugInfo) {
        return console.warn(chalk.cyan('Debug:', debugInfo));
      });
    }
  };

}).call(this);
